<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container">
            <div class="row mb-2">
                <div class="col-sm-12 text-center">
                    <h1>Quản trị Album/Image</h1>
                </div>

                <div class="mb-3 mt-3 ml-3">
                    <button class="btn btn-success" id="btn-create-album">Thêm Mới Album</button>
                </div>

            </div>
        </div><!-- /.container-fluid -->
    </section>
    <section class="content">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-body">

                            <table
                                class="table table-danger table-bordered table-striped table-hover text-center bg-light"
                                id="album-table">
                                <thead>
                                    <tr>
                                        <th>STT</th>
                                        <th>Mã Album</th>
                                        <th>Tên Album</th>
                                        <th>Mô Tả</th>
                                        <th>Ngày tạo</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>

                                </tbody>
                            </table>
                        </div>
                    </div>

                    <!-- modal create album-->
                    <div class="modal" id="modal-create-album" tabindex="-1" role="dialog">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title">Tạo Mới ALbum </h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <div class="modal-body">
                                    <div class="col-12">
                                        <div class="row">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Mã Album</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-ma-album-create" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Tên Album</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-ten-album-create" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Mô Tả</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-mo-ta-album-create" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Ngày Tạo</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="date" id="inp-ngay-tao-album-create" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="modal-footer">
                                    <button type="button" class="btn btn-success confirm-create-album">Confirm</button>
                                    <button type="button" class="btn btn-danger cancel-create-album"
                                        data-dismiss="modal">Cancel</button>
                                </div>
                            </div>
                        </div>
                    </div>



                    <!-- modal update album -->
                    <div class="modal" id="modal-update-album" tabindex="-1" role="dialog">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title">Update ALbum </h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <div class="modal-body">
                                    <div class="col-12">
                                        <div class="row">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Mã Album</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-ma-album-update" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Tên Album</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-ten-album-update" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Mô Tả</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="text" id="inp-mo-ta-album-update" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-12">
                                        <div class="row">
                                            <div class="col-4">
                                                <label for="" class="font-weight-bold">Ngày Tạo</label>
                                            </div>
                                            <div class="col-8">
                                                <input type="date" id="inp-ngay-tao-album-update" class="form-control">
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="modal-footer">
                                    <button type="button" class="btn btn-success confirm-update-album">Confirm</button>
                                    <button type="button" class="btn btn-danger cancel-update-album"
                                        data-dismiss="modal">Cancel</button>
                                </div>
                            </div>
                        </div>
                    </div>



                    <!-- modal xóa album -->
                    <div class="modal" tabindex="-1" role="dialog" id="modal-delete-album">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title">Delete Album</h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <div class="modal-body">
                                    <p>Chắc chắn xóa chứ</p>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-primary" id="btn-delete-album">Save
                                        changes</button>
                                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>
        </div>

    </section>
</body>

</html>
<script>

    $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        //định nghĩa table album
        const gCOL_ID = 0;
        const gCOL_MA_ALBUM = 1;
        const gCOL_TEN_ALBUM = 2;
        const gCOL_MO_TA = 3;
        const gCOL_NGAY_TAO = 4;
        const gCOL_ACTION = 5;
        var STT = 1;
        var gId = 0;



        const gORDER_COLS = ["id", "maAlbum", "tenAlbum", "moTa", "ngayTao"];
        var vTable = $("#album-table").DataTable({
            columns: [
                { data: gORDER_COLS[gCOL_ID] },
                { data: gORDER_COLS[gCOL_MA_ALBUM] },
                { data: gORDER_COLS[gCOL_TEN_ALBUM] },
                { data: gORDER_COLS[gCOL_MO_TA] },
                { data: gORDER_COLS[gCOL_NGAY_TAO] },
                { data: gORDER_COLS[gCOL_ACTION] }
            ],
            columnDefs: [
                {
                    targets: gCOL_ID,
                    render: function () {
                        return STT++;
                    }
                },
                {
                    "targets": gCOL_ACTION,
                    "defaultContent": `<i class="far fa-edit edit-album" style= "color : green ; cursor: pointer;" title="Edit " ></i>  
                              <i class="fas fa-trash-alt delete-album" style= "color : red ; cursor: pointer;" title="Delete"></i>`
                }
            ],
            searching: false,
        })
    
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading();
        //Gán event handler khi click vào hàng bất kỳ trong table album
        $("#album-table").on("click", "td", function () {
            onAlbumTableRowClick(this);
        });

        // gán sự kiện cho nút add album
        $("#btn-create-album").on("click", function () {
            $("#modal-create-album").modal("show");

        })
        // confirm album create
        $(document).on("click", ".confirm-create-album", function () {
            onBtnCreateAlbumClick();
        });
        // cancel album create
        $(".cancel-create-album").on("click", function () {
            $("#modal-create-album").modal("hide");
        });


        // confirm image create
        $(".confirm-create-image").on("click", function () {
            onBtnCreateImageClick();
        });

        // gán sự kiện cho nút update album
        $(document).on("click", ".edit-album", function () {
            $("#modal-update-album").modal("show");
            onAlbumTableRowClick(this);
        });
        $(".confirm-update-album").on("click", function () {
            onBtnUpdateAlbumClick();
        });
        $(".cancel-update-album").on("click", function () {
            $("#modal-update-album").modal("hide");
        });


        // gán sự kiện cho nút delete album
        $(document).on("click", ".delete-album", function () {
            $("#modal-delete-album").modal("show");
        });
        // delete album confirm
        $("#btn-delete-album").on("click", function () {
            onBtnDeleteAlbumClick();
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //hàm load trang
        function onPageLoading() {
            "use strict";
            callApiGetAllALbumShowOnTable();

        }
        //Hàm gọi APi lấy ra toàn bộ album
        function callApiGetAllALbumShowOnTable() {
            "use strict";
            $.ajax({
                url: "http://localhost:8080/album/all",
                type: "GET",

                dataType: "json",
                success: function (res) {
                    console.log(res);
                    vTable.clear();
                    vTable.rows.add(res);
                    vTable.draw();
                },
                error: function (err) {
                    console.log(err.responseText);
                }
            })

        }

        //Hàm thực thi khi click vào hàng bất kỳ
        function onAlbumTableRowClick(paramTableCell) {
            var vClickedRow = $(paramTableCell).parents("tr");
            var vRowData = vTable.row(vClickedRow).data();
            gId = vRowData.id;
            console.log("Đã click vào row có id là: " + gId);
            callAjaxApiGetAlbumById(gId);
        }


        //Hàm thực thi khi nhấn nút add album
        function onBtnCreateAlbumClick() {

            var vObj = {
                maAlbum: $("#inp-ma-album-create").val().trim(),
                tenAlbum: $("#inp-ten-album-create").val().trim(),
                moTa: $("#inp-mo-ta-album-create").val().trim()
            };

            var vCheck = validateAlbumData(vObj);
            if (vCheck == true) {

                $.ajax({
                    url: "http://localhost:8080/album/create",
                    type: "POST",
                    contentType: "application/json",
                    async: false,
                    data: JSON.stringify(vObj),
                    success: function (res) {
                        console.log(res);
                        alert("tạo album thành công");
                        window.location.reload();
                    },
                    error: function (err) {
                        console.log(err.responseText);
                    }
                });
            }

        }


        //Hàm thực thi khi nhấn nút update album
        function onBtnUpdateAlbumClick() {
            "use strict";
            if (gId == 0) {
                alert("Hãy click chọn hàng cần update");
            }
            else {
                var vObj = {
                    maAlbum: $("#inp-ma-album-update").val().trim(),
                    tenAlbum: $("#inp-ten-album-update").val().trim(),
                    moTa: $("#inp-mo-ta-album-update").val().trim()
                };
            };
            var vCheck = validateAlbumData1(vObj);
            if (vCheck) {
                $.ajax({
                    url: "http://localhost:8080/album/update/" + gId,
                    type: "PUT",
                    contentType: "application/json; charset=UTF-8",
                    data: JSON.stringify(vObj),
                    success: function (res) {
                        console.log(res);
                        alert("update album thành công");
                        window.location.reload();
                    },
                    error: function (err) {
                        console.log(err.responseText);
                    }
                });
            };
        }

        //Hàm thực thi khi nhấn nút Delete album
        function onBtnDeleteAlbumClick() {
            "use strict";
            if (gId == 0) {
                alert("Hãy click chọn hàng cần delete");
            }
            else if (confirm("Ban có muõn xóa?") == true) {
                $.ajax({
                    url: "http://localhost:8080/album/delete/" + gId,
                    type: "DELETE",
                    dataType: "json",
                    success: function (res) {
                        console.log(res);
                        alert("delete album thành công");
                        window.location.reload();
                    },
                    error: function (err) {
                        console.log(err.response);
                    }
                });
            }
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //Hàm gọi API để lấy dữ liệu album theo id
        function callAjaxApiGetAlbumById(paramId) {
            $.ajax({
                url: "http://localhost:8080/album/detail/" + paramId,
                type: "GET",
                dataType: "json",
                success: function (res) {
                    console.log(res);
                    loadAlbumDataToForm(res);
                },
                error: function (err) {
                    console.log(err.responseText);
                }
            })
        }



        //Hàm load dữ liệu album lên form
        function loadAlbumDataToForm(paramRes) {
            $("#inp-ma-album-update").val(paramRes.maAlbum);
            $("#inp-ten-album-update").val(paramRes.tenAlbum);
            $("#inp-mo-ta-album-update").val(paramRes.moTa);

            let vCreateDate = paramRes.ngayTao.slice(5, 7) + "-" + paramRes.ngayTao.slice(8, 10) + "-" + paramRes.ngayTao.slice(0, 4);
            $("#inp-ngay-tao-album-update").val(vCreateDate);

        }

        //Hàm validate create album
        function validateAlbumData(paramObj) {
            "use strict"
            if (paramObj.maAlbum === "") {
                alert("Hãy nhập mã album");
                return false;
            } else if (paramObj.tenAlbum === "") {
                alert("Hãy nhập tên album");
                return false;
            } else if (paramObj.moTa === "") {
                alert("Hãy nhập mô tả");
                return false;
            }
            else if ($("#inp-ngay-tao-album-create").val() === "") {
                alert("Hãy nhập ngày tạo");
                return false;
            }
            return true;
        }

        // validate update album
        function validateAlbumData1(paramObj) {
            "use strict"
            if (paramObj.maAlbum === "") {
                alert("Hãy nhập mã album");
                return false;
            } else if (paramObj.tenAlbum === "") {
                alert("Hãy nhập tên album");
                return false;
            } else if (paramObj.moTa === "") {
                alert("Hãy nhập mô tả");
                return false;
            }
            else if ($("#inp-ngay-tao-album-update").val() === "") {
                alert("Hãy nhập ngày tạo");
                return false;
            }
            return true;
        }

    });
</script>